=== modified file '.bzrignore'
--- .bzrignore	2012-07-05 05:00:31 +0000
+++ .bzrignore	2013-02-06 14:08:25 +0000
@@ -36,13 +36,13 @@
 doc/xml
 greeters/gtk/lightdm-gtk-greeter
 greeters/qt/lightdm-qt-greeter
-greeters/qt/*_moc.cpp
+greeters/qt/*_moc*.cpp
 greeters/qt/ui_*.h
 liblightdm-gobject/*.gir
 liblightdm-gobject/*.typelib
 liblightdm-gobject/liblightdm-gobject-1.pc
 liblightdm-qt/liblightdm-qt-2.pc
-liblightdm-qt/*_moc.cpp
+liblightdm-qt/*_moc*.cpp
 m4/*
 po/*.gmo
 po/POTFILES
@@ -56,7 +56,7 @@
 src/lightdm
 src/lightdm-guest-session-wrapper
 tests/data/passwd
-tests/src/*_moc.cpp
+tests/src/*_moc*.cpp
 tests/src/dbus-env
 tests/src/guest-account
 tests/src/initctl

=== modified file 'Makefile.am'
--- Makefile.am	2013-01-31 21:05:23 +0000
+++ Makefile.am	2013-02-06 14:08:25 +0000
@@ -2,9 +2,7 @@
 if COMPILE_LIBLIGHTDM_GOBJECT
 SUBDIRS += liblightdm-gobject
 endif
-if COMPILE_LIBLIGHTDM_QT
 SUBDIRS += liblightdm-qt
-endif
 if COMPILE_TESTS
 SUBDIRS += tests
 endif

=== modified file 'configure.ac'
--- configure.ac	2013-01-31 21:11:22 +0000
+++ configure.ac	2013-02-06 14:08:25 +0000
@@ -77,28 +77,54 @@
 AM_CONDITIONAL(COMPILE_LIBLIGHTDM_GOBJECT, test x"$compile_liblightdm_gobject" != "xno")
 
 AC_ARG_ENABLE(liblightdm-qt,
-	AS_HELP_STRING([--enable-liblightdm-qt],[Enable LightDM client QT libraries [[default=auto]]]),
-	[enable_liblightdm_qt=$enableval],
-	[enable_liblightdm_qt="auto"])
-compile_liblightdm_qt=no
-if test x"$enable_liblightdm_qt" = "xauto"; then
-    PKG_CHECK_MODULES(LIBLIGHTDM_QT, [
+	AS_HELP_STRING([--enable-liblightdm-qt],[Enable LightDM client Qt4 libraries [[default=auto]]]),
+	[enable_liblightdm_qt4=$enableval],
+	[enable_liblightdm_qt4="auto"])
+compile_liblightdm_qt4=no
+if test x"$enable_liblightdm_qt4" != "xno"; then
+    PKG_CHECK_MODULES(LIBLIGHTDM_QT4, [
         QtCore
         QtDBus
         QtGui
-    ], compile_liblightdm_qt=yes, compile_liblightdm_qt=no)
-    QT4_BINDIR=`$PKG_CONFIG Qt --variable bindir`
-    AC_CHECK_TOOLS(MOC, [moc-qt4 moc],, [$QT4_BINDIR:$PATH])
-elif test x"$enable_liblightdm_qt" = "xyes"; then
-    PKG_CHECK_MODULES(LIBLIGHTDM_QT, [
-        QtCore
-        QtDBus
-    ])
-    QT4_BINDIR=`$PKG_CONFIG Qt --variable bindir`
-    AC_CHECK_TOOLS(MOC, [moc-qt4 moc],, [$QT4_BINDIR:$PATH])
-    compile_liblightdm_qt=yes
-fi
-AM_CONDITIONAL(COMPILE_LIBLIGHTDM_QT, test x"$compile_liblightdm_qt" != "xno")
+    ],
+    [compile_liblightdm_qt4=yes
+     AC_CHECK_TOOLS(MOC4, [moc-qt4 moc])
+     if test x"$(readlink $(which $MOC4))" = xqtchooser; then
+         MOC4="$MOC4 --qt=qt4"
+     fi
+    ],
+    [if test "x$enable_liblightdm_qt4" != xauto; then
+        AC_MSG_FAILURE(
+          [--enable-liblightdm-qt was given, but test for Qt4 failed])
+      fi
+    ])
+fi
+AM_CONDITIONAL(COMPILE_LIBLIGHTDM_QT4, test x"$compile_liblightdm_qt4" != "xno")
+
+AC_ARG_ENABLE(liblightdm-qt5,
+	AS_HELP_STRING([--enable-liblightdm-qt5],[Enable LightDM client Qt5 libraries [[default=auto]]]),
+	[enable_liblightdm_qt5=$enableval],
+	[enable_liblightdm_qt5="auto"])
+compile_liblightdm_qt5=no
+if test x"$enable_liblightdm_qt5" != "xno"; then
+    PKG_CHECK_MODULES(LIBLIGHTDM_QT5, [
+        Qt5Core
+        Qt5DBus
+        Qt5Gui
+    ],
+    [compile_liblightdm_qt5=yes
+     AC_CHECK_TOOLS(MOC5, [moc])
+     if test x"$(readlink $(which $MOC5))" = xqtchooser; then
+         MOC5="$MOC5 --qt=qt5"
+     fi
+    ],
+    [if test "x$enable_liblightdm_qt5" != xauto; then
+        AC_MSG_FAILURE(
+          [--enable-liblightdm-qt5 was given, but test for Qt5 failed])
+      fi
+    ])
+fi
+AM_CONDITIONAL(COMPILE_LIBLIGHTDM_QT5, test x"$compile_liblightdm_qt5" != "xno")
 
 AC_MSG_CHECKING(whether to build tests)
 AC_ARG_ENABLE(tests,
@@ -174,6 +200,7 @@
 liblightdm-gobject/Makefile
 liblightdm-qt/Makefile
 liblightdm-qt/liblightdm-qt-2.pc
+liblightdm-qt/liblightdm-qt5-2.pc
 po/Makefile.in
 src/Makefile
 tests/Makefile
@@ -196,6 +223,7 @@
         User session:             $USER_SESSION
         liblightdm-gobject:       $compile_liblightdm_gobject
         GObject introspection:    $found_introspection
-        liblightdm-qt:            $compile_liblightdm_qt
+        liblightdm-qt:            $compile_liblightdm_qt4
+        liblightdm-qt5:           $compile_liblightdm_qt5
         Enable tests:             $enable_tests
 "

=== modified file 'liblightdm-qt/Makefile.am'
--- liblightdm-qt/Makefile.am	2012-01-09 15:56:36 +0000
+++ liblightdm-qt/Makefile.am	2013-02-06 14:08:25 +0000
@@ -1,24 +1,33 @@
-lib_LTLIBRARIES = liblightdm-qt-2.la
-
-%_moc.cpp: QLightDM/%.h
-	$(MOC) $< -o $@
-
-power.cpp: power_moc.cpp
-greeter.cpp: greeter_moc.cpp
-sessionsmodel.cpp: sessionsmodel_moc.cpp
-usersmodel.cpp: usersmodel_moc.cpp
-
-liblightdm_qt_2_la_LIBADD = \
-	$(LIBLIGHTDM_QT_LIBS) \
+%_moc4.cpp: QLightDM/%.h
+	$(MOC4) $< -o $@
+
+%_moc5.cpp: QLightDM/%.h
+	$(MOC5) $< -o $@
+
+common_libadd = \
 	-L$(top_builddir)/liblightdm-gobject \
 	-llightdm-gobject-1
+liblightdm_qt_2_la_LIBADD = \
+	$(LIBLIGHTDM_QT4_LIBS) \
+	$(common_libadd)
+liblightdm_qt5_2_la_LIBADD = \
+	$(LIBLIGHTDM_QT5_LIBS) \
+	$(common_libadd)
 
-liblightdm_qt_2_la_CXXFLAGS = $(LIBLIGHTDM_QT_CFLAGS) \
+common_cflags = \
 	-I$(top_srcdir)/liblightdm-gobject \
 	$(LIBLIGHTDM_GOBJECT_CFLAGS) \
 	-DXSESSIONS_DIR=\"$(datadir)/xsessions\"
+liblightdm_qt_2_la_CXXFLAGS = \
+	$(LIBLIGHTDM_QT4_CFLAGS) \
+	$(common_cflags)
+liblightdm_qt5_2_la_CXXFLAGS = \
+	-fPIC \
+	-DQT_DISABLE_DEPRECATED_BEFORE="QT_VERSION_CHECK(4, 0, 0)" \
+	$(LIBLIGHTDM_QT5_CFLAGS) \
+	$(common_cflags)
 
-liblightdm_qt_2include_HEADERS = \
+common_headers = \
 	QLightDM/Greeter \
 	QLightDM/Power \
 	QLightDM/SessionsModel \
@@ -29,20 +38,43 @@
 	QLightDM/usersmodel.h
 
 liblightdm_qt_2includedir=$(includedir)/lightdm-qt-2/QLightDM
+liblightdm_qt5_2includedir=$(includedir)/lightdm-qt5-2/QLightDM
 
-liblightdm_qt_2_la_SOURCES = \
+common_sources = \
 	greeter.cpp \
 	power.cpp \
 	sessionsmodel.cpp \
-	usersmodel.cpp \
+	usersmodel.cpp
+liblightdm_qt_2_la_SOURCES = \
+	$(common_sources) \
 	$(liblightdm_qt_2include_HEADERS)
+liblightdm_qt5_2_la_SOURCES = \
+	$(common_sources) \
+	$(liblightdm_qt5_2include_HEADERS)
 
 pkgconfigdir = $(libdir)/pkgconfig
-pkgconfig_DATA = liblightdm-qt-2.pc
 
 CLEANFILES = \
-	*_moc.cpp
+	*_moc*.cpp
 
 DISTCLEANFILES = \
 	Makefile.in \
 	$(pkgconfig_DATA)
+
+lib_LTLIBRARIES =
+BUILT_SOURCES =
+pkgconfig_DATA =
+
+if COMPILE_LIBLIGHTDM_QT4
+lib_LTLIBRARIES += liblightdm-qt-2.la
+liblightdm_qt_2include_HEADERS = $(common_headers)
+BUILT_SOURCES += $(common_sources:.cpp=_moc4.cpp)
+pkgconfig_DATA += liblightdm-qt-2.pc
+endif
+
+if COMPILE_LIBLIGHTDM_QT5
+lib_LTLIBRARIES += liblightdm-qt5-2.la
+liblightdm_qt5_2include_HEADERS = $(common_headers)
+BUILT_SOURCES += $(common_sources:.cpp=_moc5.cpp)
+pkgconfig_DATA += liblightdm-qt5-2.pc
+endif

=== modified file 'liblightdm-qt/greeter.cpp'
--- liblightdm-qt/greeter.cpp	2013-01-31 20:56:09 +0000
+++ liblightdm-qt/greeter.cpp	2013-02-06 14:08:25 +0000
@@ -252,4 +252,8 @@
     return QString::fromUtf8(lightdm_get_hostname());
 }
 
-#include "greeter_moc.cpp"
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+#include "greeter_moc5.cpp"
+#else
+#include "greeter_moc4.cpp"
+#endif

=== modified file 'liblightdm-qt/liblightdm-qt-2.pc.in'
--- liblightdm-qt/liblightdm-qt-2.pc.in	2011-11-30 02:39:56 +0000
+++ liblightdm-qt/liblightdm-qt-2.pc.in	2013-02-06 14:08:25 +0000
@@ -4,7 +4,7 @@
 includedir=@includedir@
 
 Name: liblightdm-qt
-Description: LightDM client library
+Description: LightDM Qt4 client library
 Version: @VERSION@
 Requires: QtCore QtGui
 Libs: -L${libdir} -llightdm-qt-2

=== added file 'liblightdm-qt/liblightdm-qt5-2.pc.in'
--- liblightdm-qt/liblightdm-qt5-2.pc.in	1970-01-01 00:00:00 +0000
+++ liblightdm-qt/liblightdm-qt5-2.pc.in	2013-02-06 14:08:25 +0000
@@ -0,0 +1,11 @@
+prefix=@prefix@
+exec_prefix=@exec_prefix@
+libdir=@libdir@
+includedir=@includedir@
+
+Name: liblightdm-qt5
+Description: LightDM Qt5 client library
+Version: @VERSION@
+Requires: Qt5Core Qt5Gui
+Libs: -L${libdir} -llightdm-qt5-2
+Cflags: -I${includedir}/lightdm-qt5-2

=== modified file 'liblightdm-qt/power.cpp'
--- liblightdm-qt/power.cpp	2013-01-31 20:56:09 +0000
+++ liblightdm-qt/power.cpp	2013-02-06 14:08:25 +0000
@@ -110,4 +110,8 @@
     d->consoleKitInterface->call("Restart");
 }
 
-#include "power_moc.cpp"
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+#include "power_moc5.cpp"
+#else
+#include "power_moc4.cpp"
+#endif

=== modified file 'liblightdm-qt/sessionsmodel.cpp'
--- liblightdm-qt/sessionsmodel.cpp	2013-01-31 20:56:09 +0000
+++ liblightdm-qt/sessionsmodel.cpp	2013-02-06 14:08:25 +0000
@@ -146,4 +146,8 @@
     return QVariant();
 }
 
-#include "sessionsmodel_moc.cpp"
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+#include "sessionsmodel_moc5.cpp"
+#else
+#include "sessionsmodel_moc4.cpp"
+#endif

=== modified file 'liblightdm-qt/usersmodel.cpp'
--- liblightdm-qt/usersmodel.cpp	2013-02-02 14:08:02 +0000
+++ liblightdm-qt/usersmodel.cpp	2013-02-06 14:08:25 +0000
@@ -241,4 +241,8 @@
 }
 
 
-#include "usersmodel_moc.cpp"
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+#include "usersmodel_moc5.cpp"
+#else
+#include "usersmodel_moc4.cpp"
+#endif

=== modified file 'tests/Makefile.am'
--- tests/Makefile.am	2012-10-10 15:56:01 +0000
+++ tests/Makefile.am	2013-02-06 14:08:25 +0000
@@ -131,7 +131,7 @@
 #   test-qt-change-password
 #   test-autologin-create-directory
 
-if COMPILE_LIBLIGHTDM_QT
+if COMPILE_LIBLIGHTDM_QT4
 TESTS += \
 	test-autologin-qt-timeout \
 	test-autologin-qt-guest-timeout \

=== modified file 'tests/src/Makefile.am'
--- tests/src/Makefile.am	2012-10-10 16:22:03 +0000
+++ tests/src/Makefile.am	2013-02-06 14:08:25 +0000
@@ -14,7 +14,7 @@
 # but produces a shared library (instead of just a static library)
 libsystem_la_LDFLAGS = -rpath /nowhere
 
-if COMPILE_LIBLIGHTDM_QT
+if COMPILE_LIBLIGHTDM_QT4
 noinst_PROGRAMS += test-qt-greeter
 endif
 
@@ -106,12 +106,12 @@
 	$(XCB_CFLAGS)
 test_qt_greeter_CXXFLAGS = \
 	-I$(top_srcdir)/liblightdm-qt \
-	$(LIBLIGHTDM_QT_CFLAGS) \
+	$(LIBLIGHTDM_QT4_CFLAGS) \
 	$(GLIB_CFLAGS)
 test_qt_greeter_LDADD = \
 	-L$(top_builddir)/liblightdm-qt \
 	-llightdm-qt-2 \
-	$(LIBLIGHTDM_QT_LIBS) \
+	$(LIBLIGHTDM_QT4_LIBS) \
 	$(GLIB_LIBS) \
 	$(GIO_UNIX_LIBS) \
 	$(XCB_LIBS)

